Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 634192 - <dev-perl/DBD-mysql-4.41.0-r2,=dev-perl/DBD-mysql-4.42.0 does not work with mariadb
Summary: <dev-perl/DBD-mysql-4.41.0-r2,=dev-perl/DBD-mysql-4.42.0 does not work with m...
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal critical (vote)
Assignee: Gentoo Perl team
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2017-10-13 18:21 UTC by Craig Andrews
Modified: 2019-10-09 21:49 UTC (History)
9 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
mariadb-10.2.patch (mariadb-10.2.patch,918 bytes, patch)
2017-10-13 19:07 UTC, Brian Evans
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Craig Andrews gentoo-dev 2017-10-13 18:21:34 UTC
dev-perl/DBD-mysql-4.41.0-r1 emerges fine, but then does not work at runtime with mariadb (specifically, I'm using dev-db/mariadb-10.2.9). I assume this issue isn't limited to just amavisd-new - I'm only using it as an example.

dev-perl/DBD-mysql-4.37.0 works fine.

When using mail-filter/amavisd-new-2.11.0-r3, amavisd-new logs this message and fails to start:
---
Oct 13 14:17:12 irrational amavis[17659]: starting. /usr/sbin/amavisd at integralblue.com amavisd-new-2.11.0 (20160426), Unicode aware, LANG="en_US.UTF-8"
Oct 13 14:17:12 irrational amavisd[17659]: fetch_modules: error loading required module DBD/mysql.pm:
Oct 13 14:17:12 irrational amavisd[17659]:   Can't load '/usr/lib64/perl5/vendor_perl/5.26.1/x86_64-linux/auto/DBD/mysql/mysql.so' for module DBD::mysql: /usr/lib64/perl5/vendor_perl/5.26.1/x86_64-linux/auto/DBD/mysql/mysql.so: undefined symbol: net_buffer_length at /usr/lib64/perl5/5.26.1/x86_64-linux/DynaLoader.pm line 193.
Oct 13 14:17:12 irrational amavisd[17659]:   
Oct 13 14:17:12 irrational amavisd[17659]:  at /usr/sbin/amavisd line 210.
Oct 13 14:17:12 irrational amavisd[17659]:   Compilation failed in require at /usr/sbin/amavisd line 210.
Oct 13 14:17:12 irrational amavisd[17659]: fetch_modules: error loading required module DBD/mysql.pm:
Oct 13 14:17:12 irrational amavisd[17659]:   Attempt to reload DBD/mysql.pm aborted.
Oct 13 14:17:12 irrational amavisd[17659]:   Compilation failed in require at /usr/sbin/amavisd line 210.
Oct 13 14:17:12 irrational amavisd[17659]: ERROR: MISSING REQUIRED ADDITIONAL MODULES:
Oct 13 14:17:12 irrational amavisd[17659]:   DBD::mysql
Oct 13 14:17:12 irrational systemd[1]: amavisd.service: Main process exited, code=exited, status=255/n/a
Oct 13 14:17:12 irrational systemd[1]: amavisd.service: Failed with result 'exit-code'.
---

$ emerge DBD-mysql -pv                    
[ebuild   R    ] dev-perl/DBD-mysql-4.41.0-r1::gentoo  USE="ssl -embedded {-test}" 0 KiB

$ emerge amavisd-new -pv                        ... done! 
[ebuild   R    ] mail-filter/amavisd-new-2.11.0-r3::gentoo  USE="dkim mysql razor spamassassin -clamav -courier -ldap -postgres -qmail -snmp -zmq" 0 KiB

$ emerge mariadb -pv
[ebuild   R    ] dev-db/mariadb-10.2.9:0/18::gentoo  USE="backup cracklib extraengine pam perl server systemd xml -bindist -debug -embedded -galera -innodb-lz4 -innodb-lzo -innodb-snappy -jdbc -jemalloc -kerberos -latin1 -libressl -mroonga -numa -odbc -oqgraph -profiling -rocksdb (-selinux) -sphinx -sst-mariabackup -sst-rsync -sst-xtrabackup -static -static-libs -systemtap -tcmalloc {-test} -tokudb -yassl" ABI_X86="(64) -32 (-x32)" 0 KiB

$ emerge --info
Portage 2.3.11 (python 3.5.4-final-0, default/linux/amd64/17.0, gcc-7.2.0, glibc-2.25-r7, 4.13.2-gentoo x86_64)
=================================================================
System uname: Linux-4.13.2-gentoo-x86_64-Intel-R-_Core-TM-_i5-6500_CPU_@_3.20GHz-with-gentoo-2.4.1
KiB Mem:    16152416 total,    437652 free
KiB Swap:   12337144 total,  11890936 free
Timestamp of repository gentoo: Fri, 13 Oct 2017 18:00:01 +0000
Head commit of repository gentoo: e2377d3fc70f03cf2aa91027e5d1fa176700c9cf
sh bash 4.4_p12
ld GNU ld (Gentoo 2.29.1 p1.0) 2.29.1
ccache version 3.3.4 [disabled]
app-shells/bash:          4.4_p12::gentoo
dev-java/java-config:     2.2.0-r3::gentoo
dev-lang/perl:            5.26.1::gentoo
dev-lang/python:          2.7.14::gentoo, 3.4.6::gentoo, 3.5.4::gentoo
dev-util/ccache:          3.3.4-r1::gentoo
dev-util/cmake:           3.9.4::gentoo
dev-util/pkgconfig:       0.29.2::gentoo
sys-apps/baselayout:      2.4.1-r2::gentoo
sys-apps/openrc:          0.33::gentoo
sys-apps/sandbox:         2.12::gentoo
sys-devel/autoconf:       2.13::gentoo, 2.69-r4::gentoo
sys-devel/automake:       1.11.6-r2::gentoo, 1.15.1-r1::gentoo
sys-devel/binutils:       2.29.1::gentoo
sys-devel/gcc:            7.2.0::gentoo
sys-devel/gcc-config:     1.9.0::gentoo
sys-devel/libtool:        2.4.6-r4::gentoo
sys-devel/make:           4.2.1-r1::gentoo
sys-kernel/linux-headers: 4.13::gentoo (virtual/os-headers)
sys-libs/glibc:           2.25-r7::gentoo
Repositories:

gentoo
    location: /usr/portage
    sync-type: rsync
    sync-uri: rsync://rsync.gentoo.org/gentoo-portage
    priority: -1000
    sync-rsync-extra-opts: 

x-portage
    location: /usr/local/portage
    masters: gentoo
    priority: 0

mv
    location: /var/lib/layman/mv
    sync-type: laymansync
    sync-uri: git://anongit.gentoo.org/user/mv.git
    masters: gentoo
    priority: 50

rust
    location: /var/lib/layman/rust
    sync-type: laymansync
    sync-uri: git://github.com/gentoo/gentoo-rust.git
    masters: gentoo
    priority: 50

steam-overlay
    location: /var/lib/layman/steam-overlay
    sync-type: laymansync
    sync-uri: git://github.com/anyc/steam-overlay.git
    masters: gentoo
    priority: 50

ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="* -@EULA Intel-SDP Oracle-BCLA-JavaSE Oracle-EADLA"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-O2 -march=native -pipe -fomit-frame-pointer -flto -fuse-linker-plugin"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/gnupg/qualified.txt /usr/share/maven-bin-3.3/conf"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php7.1/ext-active/ /etc/php/cgi-php7.1/ext-active/ /etc/php/cli-php7.1/ext-active/ /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-O2 -march=native -pipe -fomit-frame-pointer -flto -fuse-linker-plugin"
DISTDIR="/usr/portage/distfiles"
EMERGE_DEFAULT_OPTS="--jobs=4 --load-average=4.5"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-logs candy cgroup clean-logs collision-protect config-protect-if-modified distlocks ebuild-locks fixlafiles ipc-sandbox merge-sync multilib-strict network-sandbox news parallel-fetch parallel-install preserve-libs protect-owned sandbox sfperms splitdebug strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync webrsync-gpg xattr"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://distfiles.gentoo.org"
LANG="en_US.UTF-8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed -flto"
MAKEOPTS="-j5"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/var/tmp"
USE="X a52 aac aacs acl acpi aiglx alac alsa amd64 amr amrnb amrwb animation apache2 apng artworkextra asf aspnet2 asyncns authdaemond avahi avi bash-completion bcmath berkdb bitmap-fonts bluetooth bluray bmp bonjour bzip2 cairo caps cdda cddb cdparanoia cdr celt chm clang cli cracklib crypt cryptsetup css cups curl cxx daap dbus device-mapper dga dhclient dirac divx4linux dlloader dns dnssec dovecot-sasl dpms dri dri3 dts dv dvb dvd dvdr dvdread egl enca encode exif ext4 faac fam fame fat fbcondecor fbsplash ffmpeg fftw firefox flac fontconfig foomaticdb fortran freetype ftp fuse gaim gd gdbm geoip gif gimpprint glamor gles gles1 gles2 glib glibc-omitfp glitz glut gost gphoto2 gsm gstreamer gstreamer10 gtk gtk2 gudev hardenedphp hbci howl howl-compat http2 https hwdb iconv icu idn imagemagick imap imlib innodb ipv6 java java5 javafx jbig jce joystick jpeg jpeg2k junit kdbus kdehiddenvisibility kvm lapack lcms libfame libkms libnotify librtmp libusb lirc live llvm lm_sensors lvm lz4 lzma lzo mad maildir mdadm mdnsresponder-compat metalink mjpeg mmap mms mng modules motif mozilla mozsvg mp3 mpeg mpeg2 mplayer mpx multilib musepack mysql mythtv natspec ncurses nemesi network networkmanager nls nptl nptlonly ntfs ocl-icd offensive ofx ogg oggvorbis openal opencl openexr opengl openmp openvg opus pam pango pcre pcre16 pcre32 pdf pdflib perl pgo phonon pic pie png pnp policykit ppd ppds pulseaudio python qt qt3 qt3support qt4 quicktime quvi rar readline resolvconf rtc rtmp samba schroedinger screensaver sctp sdl seccomp session sftp sharedmem shout smp sna sni sox speex spell sqlite ssh ssl steamruntime suspend2 svg systemd theora threads tiff tls transcode truetype truetype-fonts type-fonts udev udisks unicode unzip upnp ups usb user-session uxa v4l2 vaapi vcd vdpau videos virgl vorbis vpx vulkan wayland webdav webp webservices wifi win32codecs wmf wv x264 x265 xanim xattr xcb xcomposite xdg xinerama xml xml2 xpm xprint xrandr xv xvfb xvid xvmc zeroconf zip zlib" ABI_X86="64" ALSA_CARDS="hda-intel" APACHE2_MODULES="actions alias auth_basic authn_core authz_core cache_disk authn_alias authn_anon authn_dbm authn_file authz_dbm authz_groupfile authz_host authz_owner authz_user autoindex cache dav dav_fs dav_lock dconf deflate dir env expires ext_filter file_cache filter headers include info log_config logio mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias auth_digest proxy proxy_ajp proxy_connect proxy_http proxy_fcgi reqtimeout cgi cgid unixd socache_shmcb proxy_html xml2enc" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump author" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="aes avx avx2 fma3 mmx mmxext popcnt sse sse2 sse3 sse4_1 sse4_2 ssse3" CURL_SSL="openssl" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" GRUB_PLATFORMS="efi-64 pc" INPUT_DEVICES="evdev joystick keyboard mouse" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LINGUAS="en" LIRC_DEVICES="userspace" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php7-1" POSTGRES_TARGETS="postgres9_5" PYTHON_SINGLE_TARGET="python3_5" PYTHON_TARGETS="python2_7 python3_5" QEMU_SOFTMMU_TARGETS="arm i386 x86_64" QEMU_USER_TARGETS="arm i386 x86_64" RUBY_TARGETS="ruby24" USERLAND="GNU" VIDEO_CARDS="intel i965 amdgpu radeon radeonsi" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CC, CPPFLAGS, CTARGET, CXX, INSTALL_MASK, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS
Comment 1 Brian Evans Gentoo Infrastructure gentoo-dev 2017-10-13 19:07:52 UTC
Created attachment 498562 [details, diff]
mariadb-10.2.patch

Try this patch since MariaDB 10.2 is compatible with 5.7
Comment 2 Kent Fredric (IRC: kent\n) (RETIRED) gentoo-dev 2017-10-13 23:47:17 UTC
The supplied patch does improve things somewhat, but tests fail with it applied:

t/15reconnect.t ......................... Failed 10/16 subtests 


t/15reconnect.t                       (Wstat: 11 Tests: 6 Failed: 0)
  Non-zero wait status: 11
  Parse errors: Bad plan.  You planned 16 tests but ran 6.


That's a SEGV

[13298659.930685] perl[8675]: segfault at 208 ip 00007f2694bbc6ee sp 00007fff1a69e220 error 4 in libmariadb.so.3[7f2694b9c000+43000]
Comment 3 Attila Tóth 2017-10-14 06:52:50 UTC
Hit the same bug affecting my spamassassin bayesian connection: spamd and sa-learn stopped functioning. I came to the same conclusion and essentially hardwired the conditional statement to be always true - functionally did the same as the proposed patch. Both spamd and sa-learn works now.
The issue has been probably brought to the surface because of the perl-5.26 upgrade and the necessary DBD-mysql recompile.
Although I haven't use the test USE flag, haven't seen perl segfaults while normal system activity - including running spamd.
Comment 4 Attila Tóth 2017-10-14 06:54:29 UTC
Nasty.
Comment 5 Brian Evans Gentoo Infrastructure gentoo-dev 2017-10-19 12:37:46 UTC
The patch should fix the DBD-mysql side.  I've reported upstream about the segfault.
Comment 6 Larry the Git Cow gentoo-dev 2017-10-19 23:54:33 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=1b0d23325cf132e9f85ec34ae6bac49f3b5f5ec8

commit 1b0d23325cf132e9f85ec34ae6bac49f3b5f5ec8
Author:     Kent Fredric <kentnl@gentoo.org>
AuthorDate: 2017-10-19 23:53:16 +0000
Commit:     Kent Fredric <kentnl@gentoo.org>
CommitDate: 2017-10-19 23:53:59 +0000

    dev-perl/DBD-mysql: Fix compiling against MariaDB 10.2 bug #634192
    
    rbump needed because compiles can break and install without errors
    if you disabled tests.
    
    Bug: https://bugs.gentoo.org/634192
    Package-Manager: Portage-2.3.8, Repoman-2.3.3

 ...4.41.0-r1.ebuild => DBD-mysql-4.41.0-r2.ebuild} |  1 +
 dev-perl/DBD-mysql/files/4.041-mariadb-10.2.patch  | 35 ++++++++++++++++++++++
 2 files changed, 36 insertions(+)}
Comment 7 Craig Andrews gentoo-dev 2017-11-16 19:32:10 UTC
It appears that this issue has been fixed - can you please confirm and mark as resolved as appropriate?
Comment 8 Leho Kraav (:macmaN @lkraav) 2019-03-15 18:00:39 UTC
Everything <DBD-mysql-4.44.0 seems to be masked by now, so probably safe to close this bug.
Comment 9 Larry the Git Cow gentoo-dev 2019-10-09 21:49:21 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=b12f7b3b83729b4a144883996e628889c8a2df78

commit b12f7b3b83729b4a144883996e628889c8a2df78
Author:     Andreas K. Hüttel <dilfridge@gentoo.org>
AuthorDate: 2019-10-09 21:48:21 +0000
Commit:     Andreas K. Hüttel <dilfridge@gentoo.org>
CommitDate: 2019-10-09 21:49:01 +0000

    dev-perl/DBD-mysql: Drop old, vulnerable and masked versions.
    
    Also drops embedded useflag support.
    
    Closes: https://bugs.gentoo.org/634192
    Closes: https://bugs.gentoo.org/598048
    Closes: https://bugs.gentoo.org/644174
    Closes: https://bugs.gentoo.org/598060
    Package-Manager: Portage-2.3.76, Repoman-2.3.17
    Signed-off-by: Andreas K. Hüttel <dilfridge@gentoo.org>

 dev-perl/DBD-mysql/DBD-mysql-4.32.0-r2.ebuild      |  49 ------
 dev-perl/DBD-mysql/DBD-mysql-4.37.0.ebuild         |  68 --------
 dev-perl/DBD-mysql/DBD-mysql-4.41.0-r2.ebuild      |  69 --------
 dev-perl/DBD-mysql/DBD-mysql-4.41.0.ebuild         |  65 --------
 dev-perl/DBD-mysql/DBD-mysql-4.42.0.ebuild         |  66 --------
 dev-perl/DBD-mysql/Manifest                        |   4 -
 .../files/4.041-amvis-type-conversions.patch       |  47 ------
 dev-perl/DBD-mysql/files/4.041-no-dot-inc.patch    | 103 ------------
 dev-perl/DBD-mysql/files/4.042-no-dot-inc.patch    | 178 ---------------------
 .../files/DBD-mysql-print_embedded_options.patch   |  20 ---
 dev-perl/DBD-mysql/metadata.xml                    |   1 -
 11 files changed, 670 deletions(-)